package
{
	import org.flixel.*;

	public class Game
	{
		public var grid : Vector.<Vector.<int>>;
		
		public static var tilesize:int=8;
		public static var width:int=12;
		public static var height:int=21;
		public static var xoffset:int=8;
		public static var yoffset:int=-16;
		public var lastunlocked:int=1;
		public var score:int=0;
		public var gameover:Boolean=false;
		
		public var unlocked:Array = [0,1,0,0,0,0,0];
		public static var piecetypes:Array = [ 
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[1,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,0,1,1],
					[0,1,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,1,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,1,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
				[
					[0,0,1,1],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,1,0,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
		];
		
		
		public static var piecemasks:Array = [ 
			[
				[
					[0,2,2,0],
					[2,1,1,2],
					[2,1,1,2],
					[0,2,2,0]
				],
			],
			[
				[
					[0,2,2,2,2,0],
					[2,1,1,1,1,2],
					[0,2,2,2,2,0]
				],
				[
					[0,2,0],
					[2,1,2],
					[2,1,2],
					[2,1,2],
					[2,1,2],
					[0,2,0]
				],
			],
			[
				[
					[0,0,2,2,0],
					[0,2,1,1,2],
					[2,1,1,2,0],
					[0,2,2,0,0]
				],
				[
					[0,2,0,0],
					[2,1,2,0],
					[2,1,1,2],
					[0,2,1,2],
					[0,0,2,0]
				],
			],
			[
				[
					[0,2,2,0,0],
					[2,1,1,2,0],
					[0,2,1,1,2],
					[0,0,2,2,0]
				],
				[
					[0,0,2,0],
					[0,2,1,2],
					[2,1,1,2],
					[2,1,2,0],
					[0,2,0,0]
				],
			],
			[
				[
					[0,2,2,2,0],
					[2,1,1,1,2],
					[2,1,2,2,0],
					[0,2,0,0,0]
				],
				[
					[0,2,2,0],
					[2,1,2,0],
					[2,1,2,0],
					[2,1,1,2],
					[0,2,2,0]
				],
				[
					[0,0,0,2,0],
					[0,2,2,1,2],
					[2,1,1,1,2],
					[0,2,2,2,0]
				],
				[
					[0,2,2,0],
					[2,1,1,2],
					[0,2,1,2],
					[0,2,1,2],
					[0,0,2,0]
				],
			],
			[
				[
					[0,2,2,2,0],
					[2,1,1,1,2],
					[0,2,2,1,2],
					[0,0,0,2,0]
				],
				[
					[0,2,2,0],
					[2,1,1,2],
					[2,1,2,0],
					[2,1,2,0],
					[0,2,0,0]
				],
				[
					[0,2,0,0,0],
					[2,1,2,2,0],
					[2,1,1,1,2],
					[0,2,2,2,0]
				],
				[
					[0,0,2,0],
					[0,2,1,2],
					[0,2,1,2],
					[2,1,1,2],
					[0,2,2,0]
				],
			],
			[
				[
					[0,2,2,2,0],
					[2,1,1,1,2],
					[0,2,1,2,0],
					[0,0,2,0,0]
				],
				[
					[0,2,0,0],
					[2,1,2,0],
					[2,1,1,2],
					[2,1,2,0],
					[0,2,0,0]
				],
				[
					[0,0,2,0,0],
					[0,2,1,2,0],
					[2,1,1,1,2],
					[0,2,2,2,0],
				],
				[
					[0,0,2,0],
					[0,2,1,2],
					[2,1,1,2],
					[0,2,1,2],
					[0,0,2,0]
				],
			],
		];
		
		
		private var allunlocked:Boolean=false;
		public var px:int=0;
		public var py:int=0;
		public var ptype:int=0;
		public var prot:int=0;
		public function Game()
		{
			grid = new Vector.<Vector.<int>>();
			for (var i:int=0;i<height;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<width;j++)
				{
					row.push(i==height-1 || j==0 || j==width-1);
				}
				grid.push(row);
			}
			SpawnNew();
		}
		
		public function DropDown():void
		{			
			if (CanFit(px,py+1,ptype,prot))
			{
				py++;
			}
			else
			{
				Place();
				SpawnNew();
			}
		}
		
		
		public function MovePiece(mx:int,my:int,mrot:int):void
		{
			var trot:int = (prot+mrot + piecetypes[ptype].length)%piecetypes[ptype].length;
			if (CanFit(px+mx,py+my,ptype,trot))
			{
				px+=mx;
				py+=my;
				prot=trot;
			}			
		}
		
		public function SpawnBoard():FlxGroup
		{
			var result:FlxGroup = new FlxGroup();
			for (var j:int=0;j<height;j++)
			{
				for (var i:int=1;i<width-1;i++)
				{
					if (grid[j][i]>0)
					{
						var s:FlxSprite = new FlxSprite(xoffset+i*tilesize,yoffset+j*tilesize);
						if (grid[j][i]==1)
							s.loadGraphic(GameState.ImgPiece);
						else
							s.loadGraphic(GameState.ImgPiece2);
						result.add(s);
					}
				}
			}
			
			for (i=0;i<4;i++)
			{
				for (j=0;j<4;j++)
				{
					if (piecetypes[ptype][prot][i][j])
					{
						s = new FlxSprite(xoffset+(i+px)*tilesize,yoffset+(j+py)*tilesize);
						s.loadGraphic(GameState.ImgPiece);
						result.add(s);
					}
				}
			}
			
			//unlocks
			allunlocked=true;
			for (i=0;i<7;i++)
			{
				if (unlocked[i]==1)
				{
					var t:FlxSprite = new FlxSprite(112+(i%2)*22,30+int(i/2)*16);
					if (i==lastunlocked)
					{
						t.loadGraphic(GameState.ImgUnlocks2,true,false,17,13);
					}
					else
					{
						t.loadGraphic(GameState.ImgUnlocks,true,false,17,13);					
					}
					t.addAnimation("main",[i]);
					t.play("main");
					result.add(t);
				}
				else
					allunlocked=false;
			}
			if (allunlocked||gameover)
			{
				var text:String = allunlocked?"YOU WON\n score: "+score:"GAME OVER";
				var tt:FlxText;
				
				tt= new FlxText(0,FlxG.height/2-16-1,FlxG.width,text);
				tt.size=16;
				tt.color = 0xcfd7b1;
				tt.alignment="center";
				tt.color=0x525252;
				result.add(tt);
				
				tt= new FlxText(0,FlxG.height/2-16+1,FlxG.width,text);
				tt.size=16;
				tt.color = 0xcfd7b1;
				tt.alignment="center";
				tt.color=0x525252;
				result.add(tt);
				
				tt= new FlxText(0,FlxG.height/2-16,FlxG.width-1,text);
				tt.size=16;
				tt.color = 0xcfd7b1;
				tt.alignment="center";
				tt.color=0x525252;
				result.add(tt);
				
				tt= new FlxText(0,FlxG.height/2-16,FlxG.width+1,text);
				tt.size=16;
				tt.color = 0xcfd7b1;
				tt.alignment="center";
				tt.color=0x525252;
				result.add(tt);
				
				tt= new FlxText(0,FlxG.height/2-16,FlxG.width,text);
				tt.size=16;
				tt.color = 0xcfd7b1;
				tt.alignment="center";
				tt.color=0xffffffff;
				result.add(tt);
			}
			return result;
		}
		
		public function CanFit(x:int,y:int,type:int,rot:int):Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					
					if (piecetypes[ptype][rot][i][j]>0)
					{
						
						if (y+j<0 || y+j>=height || x+i<0 || x+i>=width)
							return false;
						if (grid[y+j][x+i]>0)
							return false;
					}
				}
			}
			return true;
		}
		
		public function Place():void
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					if (piecetypes[ptype][prot][i][j])
					{
						grid[py+j][px+i]=1;
					}
				}
			}
			DoConnectedComponents();
		}
		
		private function DoConnectedComponents():void
		{
			var found:Boolean = true;
			while(found)
			{
				found=false;
				for (var tt:int=0;tt<piecemasks.length;tt++)
				{
					for (var tr:int=0;tr<piecemasks[tt].length;tr++)
					{
						for (var i:int=-1;i<width-piecemasks[tt][tr].length+1;i++)
						{							
							for (var j:int=-1;j<height-piecemasks[tt][tr][0].length+1;j++)
							{
								found=true;
								for (var pi:int=0;pi<piecemasks[tt][tr].length;pi++)
								{
									for (var pj:int=0;pj<piecemasks[tt][tr][pi].length;pj++)
									{
										var gridcoordx:int=i+pi;
										var gridcoordy:int=j+pj;
										if (gridcoordx<0 || gridcoordy<0 || gridcoordx>=width || gridcoordy>=height)
										{
											continue;
										}
										var masknum:int = piecemasks[tt][tr][pi][pj];
										var gridpiece:int = grid[gridcoordy][gridcoordx];
										if (masknum==1)
										{
											if (gridpiece>0)
											{
												found=false;
												break;
											}											
										}
										else if (masknum==2)
										{
											if (gridpiece!=1)
											{
												found=false;
												break;
											}
										}
									}
								}
								if (found)
								{
									//PRINT BLOCK
									for (var pi:int=0;pi<piecemasks[tt][tr].length;pi++)
									{
										for (var pj:int=0;pj<piecemasks[tt][tr][pi].length;pj++)
										{
											gridcoordx=i+pi;
											gridcoordy=j+pj;
											if (gridcoordx<0 || gridcoordy<0 || gridcoordx>=width || gridcoordy>=height)
											{
												continue;
											}
											var masknum:int = piecemasks[tt][tr][pi][pj];
											if (masknum==1)
											{
												grid[gridcoordy][gridcoordx]=2+tt;
											}											
										}									
									}
									unlocked[tt]=1;
									lastunlocked=tt;
								}
							}		
						}
					}
				}
			}
				
		}
		
		public function SpawnNew():void
		{
			score++;
			px=width/2-1;
			py=0;
			var piececount:int = 0;
			for (var i:int=0;i<unlocked.length;i++)
			{
				if (unlocked[i]==1)
					piececount++;
			}
			var newpieceidx:int = Math.random()*piececount;
			for (i=0;i<unlocked.length;i++)
			{
				if (unlocked[i]==1)
				{
					if (newpieceidx==0)
					{
						ptype=i;
						break;
					}
					newpieceidx--;
				}
			}
			ptype=lastunlocked;
			//ptype = int(Math.random()*piecetypes.length);
			prot = int(Math.random()*piecetypes[ptype].length);
			if (allunlocked==false && CanFit(px,py,ptype,prot)==false)
			{
				gameover=true;
			}
		}
		
	}
}